﻿* Encoding: UTF-8.
*Generate random clusters, mixtures
*SPSS macros by Kirill Orlov
*kior@akado.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_GENCLU*/vers2*******************************************************************.
define !KO_genclu(k= !charend('/') /p= !charend('/') /n= !charend('/') /centers= !charend('/') /spacing= !charend('/') /sizing= !charend('/')
                 /flat= !charend('/') /type= !charend('/') /weed= !charend('/') /elong= !charend('/') /rotat= !charend('/'))
!let !ok= 1
!let !elng= !head(!elong) !let !e1= !head(!tail(!elong)) !let !e2= !tail(!tail(!elong))
!if (!elng<>!null !and (!e1=!null !or !e2=!null)) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Неверное число параметров задано в ELONG.'.
!ifend
!if (!k=!null !or !p=!null !or !n=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Не задано K, P или N.'.
!ifend
!if (!k=1 !or !len(!k)>3 !or (!len(!k)=3 !and !k>100)) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Число кластеров K должно быть от 2 до 100.'.
!ifend
!if (!len(!p)>2 !or (!len(!p)=2 !and !p>50)) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Число переменных P должно быть от 1 до 50.'.
!ifend
!if (!elng<>!null !and !p=1) !then !let !ok= 0
-echo ''.
-echo '>ERROR. ELONG не может быть задано, когда P=1.'.
!ifend
!if (!tail(!tail(!n))<>!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Неверно задано N. Должно быть одно или два целых'.
-echo '>положительных числа.'.
!ifend
!if (!type='CLEAR') !then
-echo ''.
-echo '>REMINDER. Разграничение кластеров (TYPE=CLEAR) может изменить'.
-echo '>их первоначальную форму.'.
!ifend
!if (!ok) !then
 !if (!centers='RANDOM' !or !centers=!null !or !centers='EVEN') !then !let !file= !quote('temp_KO_genclu_1.sav')
- input prog.
  !if (!centers='RANDOM' !or !centers=!null) !then
-  loop #case= 1 to !k.
-   do rep v= v1 to !conc('v',!p).
-    comp v= rv.unif(-1.733,1.733).
-   end rep.
-   end case.
-  end loop.
  !else
-  loop #case= 1 to !k*!p*50.
-   do rep v= v1 to !conc('v',!p).
-    comp v= norm(1).
-   end rep.
-   end case.
-  end loop.
-  loop #case= 1 to !k*!p*50.
-   do rep v= v1 to !conc('v',!p).
-    comp v= rv.unif(-1.733,1.733).
-   end rep.
-   end case.
-  end loop.
  !ifend
- end file.
- end input prog.
- set results none errors none.
- quick clu v1 to !conc('v',!p) /criteria= cluster(!k) /method= kmeans(noupdate) /out= !file.        
- set results list errors list.
 !else !let !file= !centers
 !ifend
-set mxloops 100000.
-matrix.
-get clu /file= !file /var= cluster_.
-get c /file= !file /vari= v1 to !conc('v',!p).
-do if nrow(c)<>!k or ncol(c)<>!p.
- print /title '>ERROR. В файле координат центров число строк не равно K или'.
- print /title '>число переменных не равно P.' /space= 0.
- print /title '>!KO_GENCLU выполнен неверно.' /space= 0.
-else if any(clu<>grade(clu)).
- print /title '>ERROR. В файле координат центров номера кластеров не'.
- print /title '>порядковые числа 1, 2, ...' /space= 0.
- print /title '>!KO_GENCLU выполнен неверно.' /space= 0.
 !if (!elng<>!null) !then
- else if !e1<1 or !e1>4 or !e2<1 or !e2>4.
-  print /title '>ERROR. Два числовых параметра в ELONG не лежат в диапазоне от 1 до 4.'.
-  print /title '>!KO_GENCLU выполнен неверно.' /space= 0.
 !ifend
-save 0 /out= *.
-else.
- comp d= make(!k,!k,0).
- loop i= 1 to !p. 
-  comp v= c(:,i)*make(1,!k,1).
-  comp d= d+(v-t(v))&**2.
- end loop.
- comp d= sqrt(d).
- call setdiag(d,mmax(d)+1).
- comp nn= make(!k,3,0).
- comp nn(:,1)= clu.
- comp nn(:,3)= rmin(d).
- loop i= 1 to !k.
-  loop j= 1 to !k.
-   do if d(i,j)=nn(i,3).
-    comp nn(i,2)= j.
-    break.
-   end if.
-  end loop.
- end loop.
- comp r= make(!k,1,0).
  !if (!sizing=0) !then
-  comp r= r+exp(csum(ln(nn(:,3)))/nrow(nn))/(8* !if (!spacing='RANDOM' !or !spacing=!null) !then uniform(1,1) !else !spacing !ifend **1.8+.4).
  !else
-  loop it= 1 to 999.
-   comp dm= exp(csum(ln(nn(:,3)))/nrow(nn)).
-   comp m= 2* !if (!sizing='RANDOM' !or !sizing=!null) !then uniform(1,1) !else !sizing !ifend **2+1.
-   do if it=1.
-    comp r_min= 2*dm/((8* !if (!spacing='RANDOM' !or !spacing=!null) !then uniform(1,1) !else !spacing !ifend **1.8+.4)*(m+1)).
-    comp r_min1= r_min.
-    comp r_max= r_min*m.
-    comp r_max1= r_max.
-   else.
-    comp r_min= rmax({2*dm/((8* !if (!spacing='RANDOM' !or !spacing=!null) !then uniform(1,1) !else !spacing !ifend **1.8+.4)*(m+1)),r_min1}).
-    comp r_max= rmin({r_min*m,r_max1}).
-   end if.
-   comp x= cmin(nn(:,3)).
-   loop i= 1 to nrow(nn).
-   end loop if nn(i,3)=x.
-   comp r(nn(i,1))= r_min.
-   comp x= cmax(nn(:,3)).
-   loop i= 1 to nrow(nn).
-   end loop if nn(i,3)=x.
-   comp r(nn(i,1))= r_max.
-   loop.
-    comp doner= csum(r>0).
-    loop i= 1 to nrow(nn).
-     do if not r(nn(i,1)) and r(nn(i,2)).
-      comp r(nn(i,1))= 2*nn(i,3)/(8* !if (!spacing='RANDOM' !or !spacing=!null) !then uniform(1,1) !else !spacing !ifend **1.8+.4)-r(nn(i,2)).
-      comp r(nn(i,1))= rmin({rmax({r(nn(i,1)),r_min1}),r_max1}).
-     end if.
-    end loop.
-   end loop if csum(r>0)=doner.
-   do if doner<!k.
-    comp ind= 0.
-    loop i= 1 to nrow(nn).
-     do if not r(nn(i,1)).
-      comp ind= {ind,i}.
-     end if.
-    end loop.
-    comp nn= nn(ind(2:ncol(ind)),:).
-   else.
-    break.
-   end if.
-  end loop.
  !ifend
  !if (!tail(!n)=!null) !then
-  comp n= make(!k,1,!n).
  !else
-  comp n_min= rmin({!head(!n),!tail(!n)}).
-  comp n_max= rmax({!head(!n),!tail(!n)}).
-  comp n= uniform(!k,1).
-  comp n= rnd((n_max-n_min)/(cmax(n)-cmin(n))*(n-cmin(n))+n_min).
  !ifend
  !if (!elng='STRETCH') !then
-  comp e_min= rmin({!e1,!e2}).
-  comp e_max= rmax({!e1,!e2}).
-  comp u= uniform(!k,1)*(e_max-e_min)+e_min.
-  comp r= sqrt(!p*r&**2/(!p-1+u&**2))*make(1,!p,1).
-  comp r(:,1)= r(:,1)&*u.
-  comp rm= make(!k,!p**2,0).
-  loop i= 1 to !k.
    !if (!rotat<>'NONE') !then
-    comp u= sqrt(-2*ln(uniform(!p,!p)))&*cos(6.283185307*uniform(!p,!p)).
     !if (!rotat='RESTR') !then
-     comp u(:,1)= abs(u(:,1)).
     !ifend
-    comp rm(i,:)= reshape(-gsch(u),1,!p**2).
    !else
-    comp rm(i,:)= reshape(ident(!p),1,!p**2).
    !ifend
-  end loop.
   !let !pp= !null
   !do !i= 1 !to !p !do !j= 1 !to !p !let !pp= !conc(!pp,' ') !doend !doend
   !let !pp= !len(!pp)
-  save {clu,c,r,rm,n} /out= * /vari= cluster_ c1 to !conc('c',!p) r1 to !conc('r',!p) rm1 to !conc('rm',!pp) n.
  !else
-  save {clu,c,r,n} /out= * /vari= cluster_ c1 !if (!p<>1) !then to !conc('c',!p) !ifend r n.
  !ifend
  !if (!type='CLEAR' !and !weed<>0 !and !weed<>1 !and !weed<>!null) !then
-  write {'do rep c','='} /out= 'temp_KO_genclu.sps' /field= 1 to 20 /format= a8.
-  write !quote(!conc('1 to ',!k)) /field= 2 to 20 /format= a8.
   !do !i= 1 !to !p
-   write !quote(!conc('/c',!i,'=')) /field= 2 to 20 /format= a8.
-   write c(:,!i) /field= 2 to 20.
   !doend
  !ifend
-end if.
-end matrix.
-format cluster_ (f8).
-var lev cluster_ (nom).
 !if (!elng=!null) !then
- comp #alpha= unif(1).
- loop #case= 1 to n.
-  comp #d2= 0.
-  do rep v= v1 to !conc('v',!p).
-   comp v= norm(1).
-   comp #d2= #d2+v**2.
-  end rep.
   !if (!flat<>!null !and !flat<>0) !then !let !flt= '#flat*'
-   comp #flat= 1+ !if (!flat='RANDOM') !then #alpha* !else !flat* !ifend (cdf.chisq(#d2,!p)**(1/!p)*sqrt(!p+2)/sqrt(#d2)-1).
   !ifend
-  do rep v= v1 to !conc('v',!p) /c= c1 to !conc('c',!p).
-   comp v= !flt v*r+c.
-  end rep.
-  xsave out= 'temp_KO_genclu_2.sav' /keep= cluster_ v1 to !conc('v',!p).
- end loop.
 !ifend
 !if (!elng='STRETCH') !then
- vector c= c1 to !conc('c',!p) /r= r1 to !conc('r',!p) /rm= rm1 to !conc('rm',!pp) /#v (!p) /v (!p).
- comp #alpha= unif(1).
- loop #case= 1 to n.
-  recode v1 to !conc('v',!p) (else=0).
-  comp #d2= 0.
-  loop #i= 1 to !p.
-   comp #v(#i)= norm(1).
-   comp #d2= #d2+#v(#i)**2.
-  end loop.
   !if (!flat<>!null !and !flat<>0) !then !let !flt= '#flat*'
-   comp #flat= 1+ !if (!flat='RANDOM') !then #alpha* !else !flat* !ifend (cdf.chisq(#d2,!p)**(1/!p)*sqrt(!p+2)/sqrt(#d2)-1).
   !ifend
-  loop #i= 1 to !p.
-   comp #v(#i)= !flt #v(#i)*r(#i).
-  end loop.
-  loop #i= 1 to !p.
-   loop #j= 1 to !p.
-    comp v(#i)= v(#i)+#v(#j)*rm(#j+!p*(#i-1)).
-   end loop.
-   comp v(#i)= c(#i)+v(#i).
-  end loop.
-  xsave out= 'temp_KO_genclu_2.sav' /keep= cluster_ v1 to !conc('v',!p).
- end loop.
 !ifend
 !if (!elng='EXTEND') !then
- comp u= rv.unif(min(!e1,!e2),max(!e1,!e2)).
- comp r= sqrt(!p*r**2/(!p-1+u**2)).
- comp dcd= 2.71828183**(.4+1.42/u)*r*(u-1).
  !if (!rotat<>'NONE') !then
-  comp #dcd= 0.
-  do rep dc= dc1 to !conc('dc',!p).
-   comp dc= norm(1).
    !if (!rotat='RESTR') !then
-    comp dc= abs(dc).
    !ifend
-   comp #dcd= #dcd+dc**2.
-  end rep.
-  comp #dcd= sqrt(#dcd).
-  do rep dc= dc1 to !conc('dc',!p).
-    comp dc= dc*dcd/#dcd.
-  end rep.
  !else
-  numer dc1 to !conc('dc',!p).
-  recode dc2 to !conc('dc',!p) (else=0).
-  comp dc1= dcd.
  !ifend
- loop #case= 1 to n.
-  comp f= rv.unif(-1,1).
-  do rep c= c1 to !conc('c',!p) /v= v1 to !conc('v',!p) /dc= dc1 to !conc('dc',!p).
-   comp v= rv.norm(c+f*dc,r).
-  end rep.
-  xsave out= 'temp_KO_genclu_2.sav' /keep= cluster_ v1 to !conc('v',!p).
- end loop.
 !ifend
-exec.
-get file 'temp_KO_genclu_2.sav'.
-cache.
-exec.
-dataset copy KO_genclu#$#$._.
-dataset activ KO_genclu#$#$._.
-dataset close KO_genclu#$#$._.
-erase file 'temp_KO_genclu_2.sav'.
 !if (!type='CLEAR') !then
- set results none errors none.
- quick clu v1 to !conc('v',!p) /criteria= cluster (!k) /file= !file
        /method= classify /save= cluster (clu) distance (d_clu).
  !if (!weed<>0) !then
   !if (!weed=1 !or !weed=!null) !then
-   select if clu=cluster_.
   !else
-   do if clu<>cluster_.
-    insert file= 'temp_KO_genclu.sps' syntax= batch.
-     do if clu=c.
       !do !i= 1 !to !p
-       comp !conc('ourc',!i)= !conc('c',!i).
       !doend
-     end if.
-     do if cluster_=c.
       !do !i= 1 !to !p
-       comp !conc('otrc',!i)= !conc('c',!i).
       !doend
-     end if.
-    end rep.
-    comp d2cc= 0.
-    comp d2pc= 0.
-    do rep ourc= ourc1 to !conc('ourc',!p) /otrc= otrc1 to !conc('otrc',!p) /v= v1 to !conc('v',!p).
-     comp d2cc= d2cc+(ourc-otrc)**2.
-     comp d2pc= d2pc+(v-otrc)**2.
-    end rep.
-    comp delsc= (d_clu**2+d2cc-d2pc)/sqrt(d2cc)*unif(1).
-   end if.
-   rank delsc by clu cluster_ /n /print= no.
-   sort cases by clu cluster_ (a) delsc (d).
-   comp ndel= rnd(ndelsc*!weed).
-   do if not sysmis(delsc).
-    do if cluster_<>lag(cluster_).
-     if ndel>0 del= 1.
-    else if lag(del)<ndel.
-     comp del= lag(del)+1.
-    end if.
-   end if.
-   exec.
-   erase file 'temp_KO_genclu.sps'.
-   select if sysmis(del).
   !ifend
  !ifend
- match files file= * /rename= clu=cluster_ cluster_=clu /keep= cluster_ v1 to !conc('v',!p).
- exec.
- set results list errors list.
 !ifend
 !if (!centers='RANDOM' !or !centers=!null !or !centers='EVEN') !then
- erase file 'temp_KO_genclu_1.sav'.
 !ifend
!else.
-echo '>!KO_GENCLU не выполнен.'.
!ifend
!enddefine.

*/*!KO_ROTCLU*/vers2*******************************************************************.
define !KO_rotclu(vars= !charend('/') /rotat= !charend('/') /pc= !charend('/'))
set mxloops 10000000.
matrix.
get vars /vari= !vars /names= varsnam.
get clu /var= cluster_ /name= clunam.
comp p= ncol(vars).
comp n= nrow(vars).
do if p=1.
-print /title= '>ERROR. Переменных VARS должно быть больше одной.'.
else.
-comp noerr= 1.
-comp clu= {clu;clu(n)+1}.
-comp fst= 1.
-loop i= 1 to n.
- do if clu(i+1)>clu(i) or i=n.
-  comp means= csum(vars(fst:i,:))/(i+1-fst).
-  comp vars(fst:i,:)= vars(fst:i,:)-means(make(i+1-fst,1,1),:).
   !if (!rotat<>'FREE' !and !rotat<>'FREE_ANG' !and !rotat<>!null) !then
-   call eigen(sscp(vars(fst:i,:)),eivec,eival).
    !if (!pc='DIRECT') !then
-    loop c= 1 to p.
-     do if eivec(c,c)<0.
-      comp eivec(:,c)= -eivec(:,c).
-     end if.
-    end loop.
-    do if not det(eivec).
-     comp eivec(:,p)= -eivec(:,p).
-    end if.
    !else
-    comp ndeiv= not det(eivec).
-    loop.
-     comp c= rnd(uniform(1,p)).
-    end loop if ndeiv+mod(rsum(c),2)<>1.
-    comp eivec= eivec&*(-c+(not c))(make(p,1,1),:).
    !ifend
-   comp vars(fst:i,:)= vars(fst:i,:)*eivec.
   !ifend
   !if (!rotat<>'UNROT') !then
    !if (!rotat='FREE_ANG' !or !rotat='FREE_PAR' !or !rotat='RESTR_PAR') !then
-    do if fst=1.
    !ifend
-     comp rm= sqrt(-2*ln(uniform(p,p)))&*cos(6.283185307*uniform(p,p)).
      !if (!rotat='RESTR' !or !rotat='RESTR_PAR') !then
-      comp rm(:,1)= abs(rm(:,1)).
-      comp rm= -gsch(rm).
-      loop c= 2 to p.
-       do if rm(c,c)<0.
-        comp rm(:,c)= -rm(:,c).
-       end if.
-      end loop.
-      do if not det(rm).
-       comp rm(:,p)= -rm(:,p).
-      end if.
-      comp rm= t(rm).
      !else
-      comp rm= -gsch(rm).
-      do if not det(rm).
-       comp c= rnd((p+.49-.51)*uniform(1,1)+.51).
-       comp rm(:,c)= -rm(:,c).
-      end if.
      !ifend
    !if (!rotat='FREE_ANG' !or !rotat='FREE_PAR' !or !rotat='RESTR_PAR') !then
-    end if.
    !ifend
-   comp vars(fst:i,:)= vars(fst:i,:)*rm.
   !ifend
-  comp vars(fst:i,:)= vars(fst:i,:)+means(make(i+1-fst,1,1),:).
-  comp fst= i+1.
- else if clu(i+1)<clu(i).
-  print /title= '>ERROR. Переменная CLUSTER_ не была сортирована по возрастающей.'.
-  comp noerr= 0.
-  break.
- end if.
-end loop.
-do if noerr.
- comp names= {clunam,varsnam}.
- save {clu(1:n),vars} /outfile= * /names= names.
-end if.
end if.
end matrix.
var lev cluster_ (nom).
!enddefine.
